(function(mui, window, document, undefined) {
	mui.init();
	var new_card
	mui.plusReady(function() {
		self = plus.webview.currentWebview();
		new_card = self.new_card
	});
	
	var get = function(id) {
		return document.getElementById(id);
	};
	var qsa = function(sel) {
		return [].slice.call(document.querySelectorAll(sel));
	};
	var ui = {
		ceriUpList: get('ceriUpList'),
		ceriDownList: get('ceriDownList'),
		bankUpList: get('bankUpList'),
		bankDownList: get('bankDownList'),
		submit: get('sendMail')
	};
	ui.clearForm = function() {
		ui.ceriUpList.innerHTML = '';
		ui.ceriDownList.innerHTML = '';
		ui.bankUpList.innerHTML = '';
		ui.bankDownList.innerHTML = '';
		ui.newceriuPlaceholder();
		ui.newceridPlaceholder();
		ui.newbankuPlaceholder();
		ui.newbankdPlaceholder();
	};
	ui.getFileInputArray = function() {
		return [].slice.call(ui.ceriUpList.querySelectorAll('input[type="file"]'));

	};
	ui.getcdFileInputArray = function() {
		return [].slice.call(ui.ceriDownList.querySelectorAll('input[type="file"]'));
	};
	ui.getbuFileInputArray = function() {
		return [].slice.call(ui.bankUpList.querySelectorAll('input[type="file"]'));

	};
	ui.getbdFileInputArray = function() {
		return [].slice.call(ui.bankDownList.querySelectorAll('input[type="file"]'));
	};
	
	ui.getcdFileInputIdArray = function() {
		var fileInputArray = ui.getcdFileInputArray();
		var idArray = [];
		fileInputArray.forEach(function(fileInput) {
			if (fileInput.value != '') {
				idArray.push(fileInput.getAttribute('id'));
			}
		});
		return idArray;
	};
	
	ui.getbuFileInputIdArray = function() {
		var fileInputArray = ui.getbuFileInputArray();
		var idArray = [];
		fileInputArray.forEach(function(fileInput) {
			if (fileInput.value != '') {
				idArray.push(fileInput.getAttribute('id'));
			}
		});
		return idArray;
	};
	
	ui.getbdFileInputIdArray = function() {
		var fileInputArray = ui.getbdFileInputArray();
		var idArray = [];
		fileInputArray.forEach(function(fileInput) {
			if (fileInput.value != '') {
				idArray.push(fileInput.getAttribute('id'));
			}
		});
		return idArray;
	};
	
	ui.getFileInputIdArray = function() {
		var fileInputArray = ui.getFileInputArray();
		var idArray = [];
		fileInputArray.forEach(function(fileInput) {
			if (fileInput.value != '') {
				idArray.push(fileInput.getAttribute('id'));
			}
		});
		return idArray;
	};
	
	//ceriUpList
	var imageIndexIdNum = 0;
	ui.newceriuPlaceholder = function() {
		var fileInputArray = ui.getFileInputArray();
		if (fileInputArray &&
			fileInputArray.length > 0 &&
			fileInputArray[fileInputArray.length - 1].parentNode.classList.contains('space')) {
			return;
		}
		imageIndexIdNum++;
		var placeholder = document.createElement('div');
		placeholder.setAttribute('class', 'image-item space');
		var closeButton = document.createElement('div');
		closeButton.setAttribute('class', 'image-close');
		closeButton.innerHTML = 'X';
		closeButton.addEventListener('click', function(event) {
			event.stopPropagation();
			event.cancelBubble = true;
			setTimeout(function() {
				ui.ceriUpList.removeChild(placeholder);
			}, 0);
			return false;
		}, false);
		var fileInput = document.createElement('input');
		fileInput.setAttribute('type', 'file');
		fileInput.setAttribute('accept', 'image/*');
		fileInput.setAttribute('id', 'image-' + imageIndexIdNum);
		fileInput.addEventListener('change', function(event) {
			var file = fileInput.files[0];
			if (file) {
				var reader = new FileReader();
				reader.onload = function() {
					//处理 android 4.1 兼容问题
					var base64 = reader.result.split(',')[1];
					fileInput.setAttribute('vase', base64);
					var dataUrl = 'data:image/png;base64,' + base64;
//					console.log(dataUrl+'////////////////00000000000')
					//
					placeholder.style.backgroundImage = 'url(' + dataUrl + ')';
				}
				reader.readAsDataURL(file);
				placeholder.classList.remove('space');
				ui.newceriuPlaceholder();
			}
		}, false);
		placeholder.appendChild(closeButton);
		placeholder.appendChild(fileInput);
		ui.ceriUpList.appendChild(placeholder);
	};
	ui.newceriuPlaceholder();
	//end ceriUpList
	
	//ceriDownList
	var imageIndexIdNum1 = 0;
	ui.newceridPlaceholder = function() {
		var fileInputArray = ui.getcdFileInputArray();
		if (fileInputArray &&
			fileInputArray.length > 0 &&
			fileInputArray[fileInputArray.length - 1].parentNode.classList.contains('space')) {
			return;
		}
		imageIndexIdNum1++;
		var placeholder1 = document.createElement('div');
		placeholder1.setAttribute('class', 'image-item space');
		var closeButton = document.createElement('div');
		closeButton.setAttribute('class', 'image-close');
		closeButton.innerHTML = 'X';
		closeButton.addEventListener('click', function(event) {
			event.stopPropagation();
			event.cancelBubble = true;
			setTimeout(function() {
				ui.ceriDownList.removeChild(placeholder1);
			}, 0);
			return false;
		}, false);
		var fileInput1 = document.createElement('input');
		fileInput1.setAttribute('type', 'file');
		fileInput1.setAttribute('accept', 'image/*');
		fileInput1.setAttribute('id', 'image1-' + imageIndexIdNum1);
		fileInput1.addEventListener('change', function(event) {
			var file = fileInput1.files[0];
			if (file) {
				var reader1 = new FileReader();
				reader1.onload = function() {
					//处理 android 4.1 兼容问题
					var base64 = reader1.result.split(',')[1];
					fileInput1.setAttribute('vase1', base64);
					var dataUrl1 = 'data:image/png;base64,' + base64;
					//
//					console.log(dataUrl1+'////////////////111111111111')
					placeholder1.style.backgroundImage = 'url(' + dataUrl1 + ')';
				}
				reader1.readAsDataURL(file);
				placeholder1.classList.remove('space');
				ui.newceridPlaceholder();
			}
		}, false);
		placeholder1.appendChild(closeButton);
		placeholder1.appendChild(fileInput1);
		ui.ceriDownList.appendChild(placeholder1);
	};
	ui.newceridPlaceholder();
	//end ceriDownList
	
	//bankUpList
	var imageIndexIdNum2 = 0;
	ui.newbankuPlaceholder = function() {
		var fileInputArray = ui.getbuFileInputArray();
		if (fileInputArray &&
			fileInputArray.length > 0 &&
			fileInputArray[fileInputArray.length - 1].parentNode.classList.contains('space')) {
			return;
		}
		imageIndexIdNum2++;
		var placeholder2 = document.createElement('div');
		placeholder2.setAttribute('class', 'image-item space');
		var closeButton = document.createElement('div');
		closeButton.setAttribute('class', 'image-close');
		closeButton.innerHTML = 'X';
		closeButton.addEventListener('click', function(event) {
			event.stopPropagation();
			event.cancelBubble = true;
			setTimeout(function() {
				ui.bankUpList.removeChild(placeholder2);
			}, 0);
			return false;
		}, false);
		var fileInput2 = document.createElement('input');
		fileInput2.setAttribute('type', 'file');
		fileInput2.setAttribute('accept', 'image/*');
		fileInput2.setAttribute('id', 'image2-' + imageIndexIdNum2);
		fileInput2.addEventListener('change', function(event) {
			var file = fileInput2.files[0];
			if (file) {
				var reader2 = new FileReader();
				reader2.onload = function() {
					//处理 android 4.1 兼容问题
					var base64 = reader2.result.split(',')[1];
					fileInput2.setAttribute('vase2', base64);
					var dataUrl2 = 'data:image/png;base64,' + base64;
					//
//					console.log(dataUrl2+'/////////////////2222222')
					placeholder2.style.backgroundImage = 'url(' + dataUrl2 + ')';
				}
				reader2.readAsDataURL(file);
				placeholder2.classList.remove('space');
				ui.newbankuPlaceholder();
			}
		}, false);
		placeholder2.appendChild(closeButton);
		placeholder2.appendChild(fileInput2);
		ui.bankUpList.appendChild(placeholder2);
	};
	ui.newbankuPlaceholder();
	//end bankUpList
	
	//bankDownList
	var imageIndexIdNum3 = 0;
	ui.newbankdPlaceholder = function() {
		var fileInputArray = ui.getbdFileInputArray();
		if (fileInputArray &&
			fileInputArray.length > 0 &&
			fileInputArray[fileInputArray.length - 1].parentNode.classList.contains('space')) {
			return;
		}
		imageIndexIdNum3++;
		var placeholder3 = document.createElement('div');
		placeholder3.setAttribute('class', 'image-item space');
		var closeButton = document.createElement('div');
		closeButton.setAttribute('class', 'image-close');
		closeButton.innerHTML = 'X';
		closeButton.addEventListener('click', function(event) {
			event.stopPropagation();
			event.cancelBubble = true;
			setTimeout(function() {
				ui.bankDownList.removeChild(placeholder3);
			}, 0);
			return false;
		}, false);
		var fileInput3 = document.createElement('input');
		fileInput3.setAttribute('type', 'file');
		fileInput3.setAttribute('accept', 'image/*');
		fileInput3.setAttribute('id', 'image3-' + imageIndexIdNum3);
		fileInput3.addEventListener('change', function(event) {
			var file = fileInput3.files[0];
			if (file) {
				var reader3 = new FileReader();
				reader3.onload = function() {
					//处理 android 4.1 兼容问题
					var base64 = reader3.result.split(',')[1];
					fileInput3.setAttribute('vase3', base64);
					var dataUrl3 = 'data:image/png;base64,' + base64;
					//
//					console.log(dataUrl3+'/////////////////3333')
					placeholder3.style.backgroundImage = 'url(' + dataUrl3 + ')';
				}
				reader3.readAsDataURL(file);
				placeholder3.classList.remove('space');
				ui.newbankdPlaceholder();
			}
		}, false);
		placeholder3.appendChild(closeButton);
		placeholder3.appendChild(fileInput3);
		ui.bankDownList.appendChild(placeholder3);
	};
	ui.newbankdPlaceholder();
	//end bankDownList
	
	ui.submit.addEventListener('tap', function(event) {
		ceriUpList = ui.getFileInputIdArray();
		ceriDownList = ui.getcdFileInputIdArray();
		bankUpList = ui.getbuFileInputIdArray();
		bankDownList = ui.getbdFileInputIdArray();
		
		var imagestr = [];
		var imagestr1= [];
		var imagestr2 = [];
		var imagestr3= [];
		
		var pic = '';
		var pic1 = '';
		var pic2 = '';
		var pic3 = '';
		
		if(ceriUpList.length>1){
			for (var i=0;i<ceriUpList.length;i++) {
				pic = document.getElementById(''+ceriUpList[i]+'');
				imagestr.push(pic.getAttribute('vase'));
			}
		}else{
			pic = document.getElementById(''+ceriUpList[0]+'');
			imagestr.push(pic.getAttribute('vase'));
		}
		
		if(ceriDownList.length>1){
			for (var i=0;i<ceriDownList.length;i++) {
				pic1 = document.getElementById(''+ceriDownList[i]+'');
				imagestr1.push(pic1.getAttribute('vase1'));
			}
		}else{
			pic1 = document.getElementById(''+ceriDownList[0]+'');
			imagestr1.push(pic1.getAttribute('vase1'));
		}
		
		if(bankUpList.length>1){
			for (var i=0;i<bankUpList.length;i++) {
				pic2 = document.getElementById(''+bankUpList[i]+'');
				imagestr2.push(pic2.getAttribute('vase2'));
			}
		}else{
			pic2 = document.getElementById(''+bankUpList[0]+'');
			imagestr2.push(pic2.getAttribute('vase2'));
		}
		
		if(bankDownList.length>1){
			for (var i=0;i<bankDownList.length;i++) {
				pic3 = document.getElementById(''+bankDownList[i]+'');
				imagestr3.push(pic3.getAttribute('vase3'));
			}
		}else{
			pic3 = document.getElementById(''+bankDownList[0]+'');
			imagestr3.push(pic3.getAttribute('vase3'));
		}
		//post接口处理
		var info = {
			"idcPic_1":imagestr[0],
			"idcPic_2":imagestr1[0],
			"bnkPic_1":imagestr2[0],
			"bnkPic_2":imagestr3[0],
			"user_card":new_card
		}
		if(info.idcPic_1===''||info.idcPic_2===''||info.bnkPic_1===''||info.bnkPic_2===''){
			mui.toast('请上传完整信息！');return false;
		}
    	new ONex.Api().send('user.photoUpload',info, function(err) {
    		if(!err){
    			mui.toast(err)
    			return false;
    		}
    		clicked('_www/view/login/regsuccess.html','custom_regsuccess',{new_card:new_card})
//			mui.openWindow({
//			    id:'custom_regsuccess',
//			    url:'regsuccess.html',
//			    show:{
//			      autoShow:true,//页面loaded事件发生后自动显示，默认为true
//			      aniShow:'slide-in-right',//页面显示动画，默认为”slide-in-right“；
//			      duration:'200'//页面动画持续时间，Android平台默认100毫秒，iOS平台默认200毫秒；
//			    },
//			    extras:{new_card:new_card}
//			});
		});
		
		ui.clearForm();
//		mui.back();
	}, false);
})(mui, window, document, undefined);