mui.plusReady(function () {
	var state = app.getState();
	var userCard = state.account;
	var ifAdviser = null;
	var self = plus.webview.currentWebview();
	
	ifAdviser = self.ifAdviser;
	
	requestTheDataWithCardNum(userCard);
    
    function requestTheDataWithCardNum(cardNum){
    	var param = {};
    	if(cardNum){
    		param.cardNum = cardNum;
    	}
    	youpinRequest('getHLTRecordDetailGZ',param,function(res){
    		debug(res);
    		// mui.toast('请求成功');
    		showDetail(res);
    	},
    	function(fail){
    		mui.toast(fail);
    	},
    	function(timeout){
    		mui.toast(timeout);
    	});
    	
    	youpinRequest('getServiceList',{"cust_mcode":userCard},function(res){
    		debug(res);
    		// mui.toast('请求成功');
    		refreshTheServiceDiv(res);
    	},function(fail){
    		mui.toast(fail);
    	},function(timeout){
    		mui.toast(timeout);
    	});
    	
    }
    
    function showDetail(data){
    	
    	// 基本信息
    	var userInfo = data.userInfo;
    	refreshTheUserInfo(userInfo);
    	//病史
    	var illnessesArray = data.illnesses;
    	refreshTheIllnessDiv(illnessesArray);
    	//服务记录数组
    	var serviceHistoryArray = data.serviceHistory;
    	refreshTheServiceDiv(serviceHistoryArray);
    	
    }
    
    function refreshTheUserInfo(userInfo){
    	
		var cardNum = userInfo.user_card;
    	var phone = userInfo.phone;
    	var sex = userInfo.sex;
    	if(sex =='0'){sex = '女'}else if(sex =='1'){sex = '男'};
    	// 0：女 1：男
    	var name = userInfo.user_name;
    	var age = userInfo.birth;
		var today = new Date();
		debug(today,'today');
		var year = today.getFullYear();
		var birthday = new Date(age);
		debug(birthday,'birthday');
		var birthyear = birthday.getFullYear();
		age = year - birthyear;
    	  
    	$('#name')[0].innerHTML = name;
    	$('#phone')[0].innerHTML = phone;
    	$('#card')[0].innerHTML = cardNum;
    	$('#sex')[0].innerHTML = sex;
		if( age || age ==0){
			$('#age')[0].innerHTML = age+'岁';
		}
    	
		
		if( userInfo.height || userInfo.height == '0'){
			var height = userInfo.height;
			$('.height')[0].classList.remove('hide');
			$('#height')[0].innerHTML = height+'厘米';
		}
    	if( userInfo.weight || userInfo.weight == '0'){
			var weight = userInfo.weight;
			$('.weight')[0].classList.remove('hide');
			$('#weight')[0].innerHTML = weight+'公斤';
		}
    	
    }
    
    function refreshTheIllnessDiv(illnessesArray){
		if(illnessesArray.length){
			$('.illness-div')[0].classList.remove('hide')
		}
    	for (var i = 0 ; i<illnessesArray.length ;i++){
    		var illItem = illnessesArray[i];
    		debug(illItem);
    		var illDiv = document.createElement('div');
    		illDiv.classList.add('illness-item');
    		illDiv.innerHTML = illItem;
    		
    		$('.illness-div')[0].appendChild(illDiv);
    	}
    }
    
    function refreshTheServiceDiv(serviceHistoryArray){
		debug(ifAdviser);
		if(serviceHistoryArray.length && ifAdviser){
			$('.service-list-div')[0].classList.remove('hide');
		}
    	for (var j = 0 ; j< serviceHistoryArray.length ; j++){
    		var serviceItem = serviceHistoryArray[j];
    		debug(serviceItem);
    		
    		var serviceDiv = document.createElement('div');
    		serviceDiv.classList.add('service-item');
    		serviceDiv.setAttribute('record_id',serviceItem.record_id);
    		serviceDiv.addEventListener('tap',seeTheRecordDetail);
    		
    		var numSpan = document.createElement('span');
    		numSpan.id = 'num';
    		numSpan.innerHTML = j+1;
    		serviceDiv.appendChild(numSpan);
    		
    		var serviceContentDiv = document.createElement('div');
    		serviceContentDiv.classList.add('service-item-content');
    		serviceDiv.appendChild(serviceContentDiv);
    		
    		var serviceNameSpan = document.createElement('span');
    		serviceNameSpan.id = 'service-name';
    		serviceNameSpan.innerHTML = serviceItem.service_subclass;
    		serviceContentDiv.appendChild(serviceNameSpan);
    		
    		var adviserSpan = document.createElement('span');
    		adviserSpan.id = 'adviser';
    		adviserSpan.innerHTML = '健康顾问:'+serviceItem.cons_name;
    		serviceContentDiv.appendChild(adviserSpan);
    		
    		var serviceDateDiv = document.createElement('div');
    		serviceDateDiv.id = 'service-date';
    		serviceDateDiv.innerHTML = serviceItem.update_time;
    		serviceContentDiv.appendChild(serviceDateDiv);
    		
    		var serviceDetailSpan = document.createElement('span');
    		serviceDetailSpan.id = 'service-detail';
    		serviceDetailSpan.classList.add('service-detail');
    		serviceDetailSpan.innerHTML = '查看详情';
    		serviceDetailSpan.setAttribute('value',serviceItem.appoint_no);
    		serviceDiv.appendChild(serviceDetailSpan);
    		
    		var arrowSpan = document.createElement('span');
    		arrowSpan.classList.add('mui-icon','mui-icon-arrowright');
    		serviceDiv.appendChild(arrowSpan);
    		
    		$('.service-content')[0].appendChild(serviceDiv);
    	}
    }
    
    function seeTheRecordDetail(){
    	var recordEle = this;
    	var record_id = recordEle.getAttribute('record_id');
    	debug(record_id,'seeTheRecordDetail');
    	clicked('service-history.html','service-history',{'recordID':record_id});
    }
})
