mui.plusReady(function() {
	var orderId;
	var orderDetail = null;
	var self = plus.webview.currentWebview();

	if (self.orderId) {
		orderId = self.orderId;
		requestTheOrderDetail(orderId);
	}

	function requestTheOrderDetail(rID) {
		var method = 'serviceOrderDetail' + rID;
		var param = {};
		youpinRequest(method, param, function(res) {
			// mui.toast('请求成功');
			debug(res);
			orderDetail = res.appoint;
			showDetail(res);
		}, function(fail) {
			mui.toast(fail);
		}, function(timeout) {
			mui.toast(timeout);
		});
	}
	
	document.addEventListener('refreshTheDetail',function(){
		requestTheOrderDetail(orderId);
	});

	function showDetail(res) {
		var detail = res.appoint;
		var state = detail.state;
		if (state == -1) {
			state = '已取消';
		} else if (state == 0) {
			state = '预约中';
		} else if (state == 1) {
			state = '已预约';
		} else if (state == 2) {
			state = '服务中';
		} else if (state == 3) {
			state = '已完成';
		}
		// 已预约：0 已接单：1 服务中：2 已完成：3 已取消：-1
		$('#state')[0].innerHTML = state;

		var storeAddress = detail.mloc_addr1;
		$('#store-address')[0].innerHTML = storeAddress;

		var storeTel = detail.mloc_telno;
		$('#store-tel')[0].innerHTML = storeTel;

		var orderNum = detail.appoint_no;
		$('#detail-order-num')[0].innerHTML = orderNum;
		// createQrcode(orderNum);

		var storeName = detail.mloc_locnm;
		$('#store-name')[0].innerHTML = storeName;
		$('.service-store')[0].setAttribute('loccd',detail.loccd); 

		var serviceImg = detail.service_photo;
		$('#service-img')[0].setAttribute('src', serviceImg);

		var serviceName = detail.sku_name;
		$('#service-name')[0].innerHTML = serviceName;

		var serviceDuration = detail.sku_duration;
		$('#service-desc')[0].innerHTML = '时长：' + serviceDuration + '分钟';
		$('#detail-duration')[0].innerHTML = serviceDuration + '分钟';

		var servicePrice = detail.sku_price;
		// $('#price')[0].innerHTML = servicePrice;
		// $('#detail-service-price')[0].innerHTML = '￥' + servicePrice;

		var adviser = detail.cons_name;
		$('#detail-adviser')[0].innerHTML = adviser;

		var serviceOrderTime = detail.timeslice;
		var serviceOrderDate = detail.appoint_time;
		$('#detail-service-order-time')[0].innerHTML = serviceOrderDate + ' ' + serviceOrderTime;

		var customer = detail.cust_name;
		$('#detail-customer')[0].innerHTML = customer;

		var cardMes = res.card;
		var cardId = '';
		if(cardMes){
			var pid = cardMes.pid;
			var typeValue = '('+cardMes.typeValue+')';
			if(typeValue == '尊享卡'){
				var active_time = cardMes.active_time;
				if(!active_time){
					typeValue = '（未激活尊享卡）'
				}
			}
			cardId = pid + typeValue;
		}
		
		$('#detail-card-id')[0].innerHTML = cardId;

		var makeOrderTime = detail.create_time;
		$('#detail-make-order-time')[0].innerHTML = makeOrderTime;

		var remarks = detail.rem;
		$('#detail-remarks')[0].innerHTML = remarks;

		// var qrcodeimg = detail.qrcode;
		// var qrcodeEle = document.getElementById("code-qrcode");
		// qrcodeEle.setAttribute('src', qrcodeimg);
		// refreshImg(qrcodeimg);

		// 已预约：取消订单
		// 已接单：取消订单
		// 服务中：知情同意书
		// 已完成：服务记录、知情同意书
		// 已取消：再次下单

		// stateString = '已取消';
		
		$('.button-div')[0].innerHTML = '';
		if (state == '已预约' || state == '预约中') {
			var btnEle = document.createElement('button');
			btnEle.classList.add('cancel-btn');
			btnEle.innerHTML = '取消订单';
			$('.button-div')[0].appendChild(btnEle);
			btnEle.addEventListener('tap', cancelTheOrder);
		} else if (state == '服务中') {
			var btnEle = document.createElement('button');
			btnEle.classList.add('consent-btn');
			btnEle.innerHTML = '知情同意书';
			$('.button-div')[0].appendChild(btnEle);
			btnEle.addEventListener('tap', showTheConsent);
		} else if (state == '已完成') {

			// var recordBtn = document.createElement('button');
			// recordBtn.classList.add('consent-btn');
			// recordBtn.innerHTML = '服务记录';
			// $('.button-div')[0].appendChild(recordBtn);
			// recordBtn.addEventListener('tap', showTheServiceRecord);

			var btnEle = document.createElement('button');
			btnEle.classList.add('consent-btn');
			btnEle.innerHTML = '知情同意书';
			$('.button-div')[0].appendChild(btnEle);
			btnEle.addEventListener('tap', showTheConsent);

		} else if (state == '已取消') {

			// var btnEle = document.createElement('button');
			// btnEle.classList.add('consent-btn');
			// btnEle.innerHTML = '再次下单';
			// $('.button-div')[0].appendChild(btnEle);
			// btnEle.addEventListener('tap', makeOrderAgain);
		}

	}
	
	function refreshImg(imgUrl){
		debug('refresh');
		var dateString = new Date();
		dateString = dateString.getTime();
		var dtask = plus.downloader.createDownload(imgUrl, {
			filename: "_downloads/"+dateString +'/qrcodeImg.jpg'
		}, function(d, status) {
			debug(d,status);
			// 下载完成
			if (status == 200) {
				console.log("Download success: " + d.filename);
				var sd_path = plus.io.convertLocalFileSystemURL(d.filename);
		
				pathToBase64(sd_path)
					.then(base64 => {
						// console.log(base64)
						$('#code-qrcode').attr('src', base64);
					})
					.catch(error => {
						console.error(error)
					})
			} else {
				console.log("Download failed: " + status);
			}
		});
		
		dtask.start();
	}

	function makeOrderAgain(event) {
		debug('再次下单');
		var service_id = orderDetail.service_id;
		debug(service_id, 'service_id');
		clicked('service-detail.html', 'service-detail', {
			'serviceID': service_id
		});
	}

	function showTheServiceRecord(event) {
		debug('服务记录');
		var orderNum = orderDetail.appoint_no;
		debug(orderNum, 'orderNum');
		clicked('service-history.html', 'service-history', {
			'orderNum': orderNum
		});
	}

	function showTheConsent(event) {
		debug('知情同意书');
		var orderNum = orderDetail.appoint_no;
		clicked('consent.html', 'consent', {
			'orderNum': orderNum
		});
	}

	function cancelTheOrder() {
		debug('cancelTheOrder');
		var orderNum = orderDetail.appoint_no;
		mui.confirm('您确定要取消此订单吗？','', ['再等等', '立即取消'], function(e) {
			debug(e.index);
			if (e.index == 1) {
				debug('立即取消');
				clicked('cancel-reason.html','cancel-reason',{'appoint_no':orderNum});

				// var method = 'cancelTheOrder';
				// var param = {
				// 	'type': '1',
				// 	'appoint_no': orderNum
				// };
				// youpinRequest(method, param, function(res) {
				// 	mui.toast(res);
				// 	mui.back();
				// }, function(fail) {
				// 	mui.toast(fail);
				// }, function(timeout) {
				// 	mui.toast(timeout);
				// });

			}

		});
	}


	function createQrcode(num) {
		debug(num, 'num');
		var string = num.toString();
		debug(string);
		var qcodeImg = document.getElementById("code-qrcode");
		var qrcode = new QRCode(qcodeImg, {
			text: string,
			width: 130,
			height: 130
		});
	}



	mui('.mui-content').on('tap', '.service-store', function() {
		var loccd = this.getAttribute('loccd');
		var storeView = plus.webview.getWebviewById('store_index');
		if(storeView){
			mui.fire(storeView,'refreshTheStore',{'loccd':loccd});
			storeView.show();
		}
		
	});

	debug('service-order-detail');

	mui('.mui-content').on('tap', '#connect', function() {
		debug('phone');
		var phoneNum = orderDetail.mloc_telno;
		if (phoneNum) {
			plus.device.dial(phoneNum, true);
		}
	});
	
	mui('.mui-bar').on('tap','.mui-action-back',function(){
		debug('back click');
		var makeOrderView = plus.webview.getWebviewById('service-make-order');
		if (makeOrderView) {
			plus.webview.close(makeOrderView);
		}
	});

	// document.getElementById('code-save').addEventListener('tap', function() {

	// 	html2canvas(document.getElementById('code-qrcode'), {
	// 		scale: 4,
	// 		dpi: 300
	// 	}).then(canvas => {
	// 		var imgUri = canvas.toDataURL('image/png', 1.0);
	// 		var bitmap = new plus.nativeObj.Bitmap();
	// 		bitmap.loadBase64Data(imgUri, function(e) {
	// 			// console.log('loadBase64Data');
	// 			var date = new Date();
	// 			debug(date, 'date');
	// 			bitmap.save('_doc/' + date + '.png', {
	// 				overwrite: true,
	// 				format: 'png',
	// 				quality: 100,
	// 				clip: {
	// 					top: '0px',
	// 					left: '0px',
	// 					width: '100%',
	// 					height: '100%'
	// 				}
	// 			}, function(e) {
	// 				//console.log(e.target);
	// 				//thumbs = plus.io.convertLocalFileSystemURL(e.target);
	// 				//console.log(thumbs);
	// 				plus.gallery.save(e.target, function() {
	// 					mui.toast('保存成功');
	// 				}, function(error) {
	// 					mui.toast(error.message);
	// 				});
	// 			}, function(error) {
	// 				mui.toast(error.message);
	// 			});
	// 		}, function(error) {
	// 			mui.toast(error.message);
	// 		})

	// 	});
	// });

})
