var draw = 0;
var length = 10;
var start;
var state = -2;
var orderList = [];
var finish = false;

function showOrderList(list) {
	
	if(orderList && orderList.length){
		document.getElementById('empty').classList.add('hide');
		document.getElementById('emptyDes').classList.add('hide');
	}else{
		document.getElementById('empty').classList.remove('hide');
		document.getElementById('emptyDes').classList.remove('hide');
	}
	
	for (var i = 0; i < list.length; i++) {

		var orderItem = list[i];

		var orderDiv = document.createElement('div');
		orderDiv.classList.add('order-item');
		$('.order-list-scroll')[0].appendChild(orderDiv);
		orderDiv.setAttribute('orderId', orderItem.id);

		var titleDiv = document.createElement('div');
		titleDiv.classList.add('title');
		orderDiv.appendChild(titleDiv);

		var iconSpan = document.createElement('span');
		iconSpan.id = 'icon';
		iconSpan.innerHTML = '预约';
		if (orderItem.isCall == 1 && orderItem.type == 2) {
			iconSpan.innerHTML = '门店指派';
		}else if(orderItem.isCall == 0 && orderItem.type == 2){
			iconSpan.innerHTML = '代预约';
		}
		titleDiv.appendChild(iconSpan);

		var storeSpan = document.createElement('span');
		storeSpan.id = 'store';
		storeSpan.innerHTML = orderItem.mloc_locnm;
		titleDiv.appendChild(storeSpan);

		var stateSpan = document.createElement('span');
		stateSpan.id = 'state';
		// 状态 已预约：0 已接单：1 服务中：2 已完成：3 已取消：-1
		var stateString = orderItem.state;
		if (stateString == 0) {
			stateString = '预约中';
		} else if (stateString == 1) {
			stateString = '已预约';
		} else if (stateString == 2) {
			stateString = '服务中';
		} else if (stateString == 3) {
			stateString = '已完成';
		} else if (stateString == -1) {
			stateString = '已取消';
		}

		stateSpan.innerHTML = stateString;
		titleDiv.appendChild(stateSpan);

		var orderNumDiv = document.createElement('div');
		orderNumDiv.classList.add('orderNum-div');
		orderNumDiv.innerHTML = '服务单号：' + orderItem.appoint_no;
		titleDiv.appendChild(orderNumDiv);

		var orderTimeDiv = document.createElement('div');
		orderTimeDiv.classList.add('service-order-time');
		orderTimeDiv.innerText = '预约服务时间：';
		orderDiv.appendChild(orderTimeDiv);

		var timeSpan = document.createElement('span');
		timeSpan.id = 'service-order-time';
		timeSpan.innerHTML = orderItem.appoint_time + ' ' + orderItem.timeslice;
		orderTimeDiv.appendChild(timeSpan);

		var customerSpan = document.createElement('span');
		customerSpan.id = 'service-order-customer';
		customerSpan.innerHTML = '顾客：' + orderItem.cust_name;
		orderTimeDiv.appendChild(customerSpan);

		var serviceDiv = document.createElement('div');
		serviceDiv.classList.add('service-div');
		orderDiv.appendChild(serviceDiv);

		var imgEle = document.createElement('img');
		imgEle.setAttribute('src', orderItem.service_photo);
		serviceDiv.appendChild(imgEle);

		var serviceContentDiv = document.createElement('div');
		serviceContentDiv.classList.add('service-content');
		serviceDiv.appendChild(serviceContentDiv);

		var serviceTitleDiv = document.createElement('div');
		serviceTitleDiv.classList.add('service-title');
		serviceTitleDiv.innerHTML = orderItem.sku_name;
		serviceContentDiv.appendChild(serviceTitleDiv);

		var serviceDesDiv = document.createElement('div');
		serviceDesDiv.classList.add('service-desc');
		serviceDesDiv.innerHTML = '时长：' + orderItem.sku_duration + '分钟';
		serviceContentDiv.appendChild(serviceDesDiv);

		var buttonDiv = document.createElement('div');
		buttonDiv.classList.add('button-div');
		orderDiv.appendChild(buttonDiv);

		var btnOrderTimeSpan = document.createElement('span');
		btnOrderTimeSpan.classList.add('make-order-time');
		btnOrderTimeSpan.innerHTML = orderItem.create_time;
		buttonDiv.appendChild(btnOrderTimeSpan);

		var appoint_no = orderItem.appoint_no;

		var leftBtn = document.createElement('button');
		leftBtn.classList.add('left');
		leftBtn.setAttribute('type', 'button');
		leftBtn.setAttribute('value', appoint_no);

		var rightBtn = document.createElement('button');
		rightBtn.classList.add('right');
		rightBtn.setAttribute('type', 'button');
		rightBtn.setAttribute('value', appoint_no);
		// 已预约：取消订单
		// 已接单：取消订单
		// 服务中：知情同意书
		// 已完成：服务记录、知情同意书
		// 已取消：再次下单

		// stateString = '已取消';

		if (stateString == '预约中' || stateString == '已预约') {

			rightBtn.innerHTML = '取消订单';
			rightBtn.addEventListener('tap', cancelTheOrder);
			buttonDiv.appendChild(rightBtn);

		} else if (stateString == '服务中') {

			rightBtn.innerHTML = '知情同意书';
			rightBtn.addEventListener('tap', showTheConsent);
			buttonDiv.appendChild(rightBtn);

		} else if (stateString == '已完成') {

			// leftBtn.innerHTML = '服务记录';
			// leftBtn.addEventListener('tap', showTheServiceRecord);
			// buttonDiv.appendChild(leftBtn);

			rightBtn.innerHTML = '知情同意书';
			rightBtn.addEventListener('tap', showTheConsent);
			buttonDiv.appendChild(rightBtn);
		} else if (stateString == '已取消') {

			rightBtn.innerHTML = '查看详情';
			rightBtn.addEventListener('tap', showTheDetail);
			buttonDiv.appendChild(rightBtn);
			rightBtn.setAttribute('orderId', orderItem.id);

		}

	}

}

function requestTheOrderList(rstate, rpage) {
	debug('requestTheOrderList');
	// {"draw": 0, "length": 100,"start": 0,"params": {"state": -2,"type": 1}}
	// state:已预约：0 已接单：1 服务中：2 已完成：3 已取消：-1 全部：-2
	var method = 'serviceOrderList';
	var param = {};
	param.draw = rpage;
	param.length = length;
	if (start) {
		param.start = start;
	}
	var params = {};
	params.state = rstate;
	params.type = '2';
	param.params = params;
	debug(param);
	youpinRequest(method, param, function(res) {
		// mui.toast('请求成功');
		orderList = orderList.concat(res.data);
		showOrderList(res.data);
		if (res.data.length) {
			draw++;
		} else {
			finish = true;
		}
	}, function(fail) {
		mui.toast(fail);
	}, function(timeout) {
		mui.toast(timeout);
	});
};

function pullfresh() {
	draw = 0;
	$('.order-list-scroll')[0].innerHTML = '';
	orderList = [];
	finish = false;
	requestTheOrderList(state, draw);
	setTimeout(function() {
		mui('#refreshContainer').pullRefresh().endPulldownToRefresh();
		mui('#refreshContainer').pullRefresh().refresh(true);
	}, 500);
	
};

function getMore() {
	debug('get more');
	requestTheOrderList(state, draw);
	setTimeout(function() {
		mui('#refreshContainer').pullRefresh().endPullupToRefresh(finish);
	}, 500);
	
}

function cancelTheOrder(event) {
	debug('取消订单');
	event.stopPropagation();
	var orderNum = this.getAttribute('value');
	debug(orderNum, 'orderNum');
	mui.confirm('您确定要取消此订单吗？', '', ['再等等', '立即取消'], function(e) {
		debug(e.index);
		if (e.index == 1) {
			debug('立即取消');
			// requestCancelTheOrder(orderNum);
			clicked('cancel-reason.html', 'cancel-reason', {
				'appoint_no': orderNum
			});
		}

	});
}

function showTheDetail(event){
	debug('查看详情');
	event.stopPropagation();
	var orderId = this.getAttribute('orderId');
	debug(orderId, 'detail');
	clicked('service-order-detail.html', 'service-order-detail', {
		'orderId': orderId
	});
}

function requestCancelTheOrder(num) {
	var method = 'cancelTheOrder';
	var param = {
		'type': '1',
		'appoint_no': num
	};
	youpinRequest(method, param, function(res) {
		mui.toast(res);
	}, function(fail) {
		mui.toast(fail);
	}, function(timeout) {
		mui.toast(timeout);
	});
}

function showTheConsent(event) {
	event.stopPropagation();
	debug('知情同意书');
	var orderNum = this.getAttribute('value');
	debug(orderNum, 'orderNum');
	clicked('consent.html', 'consent', {
		'orderNum': orderNum
	});
}

function showTheServiceRecord(event) {
	event.stopPropagation();
	debug('服务记录');
	var orderNum = this.getAttribute('value');
	debug(orderNum, 'orderNum');
	clicked('service-history.html', 'service-history', {
		'orderNum': orderNum
	});
}

function makeOrderAgain(event) {
	event.stopPropagation();
	debug('再次下单');
	var service_id = this.getAttribute('service_id');
	debug(service_id, 'service_id');
	clicked('service-detail.html', 'service-detail', {
		'serviceID': service_id
	});
}

mui.init({
	pullRefresh: {
		container: "#refreshContainer", //下拉刷新容器标识，querySelector能定位的css选择器均可，比如：id、.class等
		down: {
			style: 'circle', //必选，下拉刷新样式，目前支持原生5+ ‘circle’ 样式
			contentinit: '下拉可以刷新',
			contentdown: '下拉可以刷新',
			contentover: '释放立即刷新',
			contentrefresh: '正在刷新...',
			auto: true, //可选,默认false.首次加载自动上拉刷新一次
			callback: pullfresh //必选，刷新函数，根据具体业务来编写，比如通过ajax从服务器获取新数据；
		},
		up: {
			height:100,
			auto:false,
			contentdown:'上拉加载更多',
			callback: getMore //必选，刷新函数，根据具体业务来编写，比如通过ajax从服务器获取新数据；
		}
	}
});

mui.plusReady(function() {

	mui('.mui-scroll-wrapper').scroll({
		deceleration: 0.0005 //flick 减速系数，系数越大，滚动速度越慢，滚动距离越小，默认值0.0006
	});

	// requestTheOrderList(state, draw);

	mui('.mui-content').on('tap', '.order-item', function() {
		var orderId = this.getAttribute('orderId');
		debug(orderId, 'detail');
		clicked('service-order-detail.html', 'service-order-detail', {
			'orderId': orderId
		});
	});

	mui('.mui-content').on('tap', '.mui-control-item', function() {
		 mui('#refreshContainer').pullRefresh().scrollTo(0, 0, 100);
		// mui('.order-list').scroll().scrollTo(0, 0, 100);
		debug(this.innerHTML);
		debug(this.getAttribute('state'));
		state = this.getAttribute('state');
		draw = 0;
		$('.order-list-scroll')[0].innerHTML = '';
		orderList = [];
		finish = false;
		requestTheOrderList(state, draw);
		mui('#refreshContainer').pullRefresh().refresh(true);
	});

	document.addEventListener('refreshTheList', function() {
		mui('.order-list').scroll().scrollTo(0, 0, 100);
		draw = 0;
		$('.order-list-scroll')[0].innerHTML = '';
		orderList = [];
		finish = false;
		requestTheOrderList(state, draw);
	});
	
	mui('.mui-bar').on('tap','.mui-action-back',function(){
		debug('back click');
		var makeOrderView = plus.webview.getWebviewById('service-make-order');
		if (makeOrderView) {
			plus.webview.close(makeOrderView);
		}
	});

})
