mui.plusReady(function() {
	var storeMes = null;
	var solutions = null;
	var advisers = null;
	var lng = null;
	var lat = null;
	var name = null;
	var address = null;
	var city = null;
	refreshTheTab();
	document.addEventListener('refreshTheTab',refreshTheTab);
	
	var state = app.getState();
	if (state.sign) {
		var count = _xsdData.xsdCartCountGt();
		_xsdData.xsdShowCartCount(count);
		}
	// 显示门店健康顾问信息
	function showAdvisers(list) {

		var count = list.length;
		$('#adviser-count')[0].innerHTML = count;

		if (count) {
			if (count > 3) {
				count = 3;
			}
			for (var i = 0; i < count; i++) {
				var adviser = list[i];

				var adviserDiv = document.createElement('div');
				adviserDiv.classList.add('store-user-content-item');
				$('.store-user-content')[0].appendChild(adviserDiv);

				var avatarDiv = document.createElement('div');
				avatarDiv.id = 'avatar';
				adviserDiv.appendChild(avatarDiv);

				var imgEle = document.createElement('img');
				imgEle.setAttribute('src', adviser.avator);
				avatarDiv.appendChild(imgEle);

				var nameDiv = document.createElement('div');
				nameDiv.id = 'name';
				nameDiv.innerHTML = adviser.name;
				adviserDiv.appendChild(nameDiv);

				var serviceCountDiv = document.createElement('div');
				serviceCountDiv.id = 'servicecount';
				serviceCountDiv.innerHTML = '已接' + adviser.serviceCount + '单';
				adviserDiv.appendChild(serviceCountDiv);

				var buttonEle = document.createElement('button');
				buttonEle.classList.add('mui-btn', 'mui-btn-grey');
				buttonEle.setAttribute('type', 'button');
				buttonEle.innerHTML = '预约';
				buttonEle.setAttribute('adviserID', adviser.ID)
				buttonEle.addEventListener('tap', showTheAdviser);
				adviserDiv.appendChild(buttonEle);

			}
		}
	}

	function showTheAdviser() {
		var btn = this;
		var adviserID = btn.getAttribute('adviserID');
		var param = {
			'loccd': storeMes.mloc_loccd,
			'adviserID': adviserID
		};
		if (lat && lng) {
			param.lat = lat;
			param.lng = lng;
		}
		param.storeMes = storeMes;
		clicked('adviser-detail.html', 'adviser-detail', param);

	}

	// 根据门店编号和当前位置获取门店健康顾问列表
	function requestTheAdviserList(loccd, slat, slng) {
		debug('storeAdviserList');
		var method = 'storeAdviserList';
		var param = {};
		param.storeNum = loccd;
		if (slat && slng) {
			param.lng = slng;
			param.lat = slat;
		}
		param.keyWord = '';
		$('#adviser-count')[0].innerHTML = '';
		$('.store-user-content')[0].innerHTML = '';
		youpinRequest(method, param, function(res) {
			// mui.toast('请求成功');
			// debug(res, method);
			advisers = res.advisers;
			showAdvisers(advisers);
		}, function(fail) {
			mui.toast(fail);
			// requestTheAdviserList(loccd,slat,slng);
		}, function(timeout) {
			mui.toast(timeout);
		});

	}

	// 通过经纬度和门店编号获取门店信息
	function getTheStoreMessageWithPoint(slng, slat, loccd) {
		var param = {};
		if (slng && slat) {
			param.x = slng;
			param.y = slat;
		}
		if (loccd) {
			param.loccd = loccd;
		}

		youpinRequest('nearest', param, function(res) {
				// mui.toast('请求成功');
				debug(res);
				if(res){
					storeMes = res;
					showStoreMessage(res);
					requestTheAdviserList(storeMes.mloc_loccd, slat, slng);
				}else{
					$('.store-Num')[0].innerHTML = '请选择';
					mui.alert('当前范围内暂无门店，请手动选择门店。','','确定',function(){
						debug('go to the store choose');
						
						var param = {};
						if (lat && lng && name && address) {
							param.lat = lat;
							param.lng = lng;
							param.name = name;
							param.address = address;
						}
						param.type = 'store';
						if(city && city.length){
							param.city = city;
						}
						
						clicked('store-choose.html', 'store-choose', param);
						
					});
				}
				
			},
			function(fail) {
				$('.store-Num')[0].innerHTML = '请选择';
				mui.alert('当前范围内暂无门店，请手动选择门店。','','确定',function(){
					debug('go to the store choose');
					
					var param = {};
					if (lat && lng && name && address) {
						param.lat = lat;
						param.lng = lng;
						param.name = name;
						param.address = address;
					}
					param.type = 'store';
					if(city && city.length){
						param.city = city;
					}
					
					clicked('store-choose.html', 'store-choose', param);
					
				});
			},
			function(timeout) {
				mui.toast(timeout);
			});
	}
	// 显示门店信息
	function showStoreMessage(storeItem) {
		$('.store-Num')[0].innerHTML = 'NO.' + storeItem.mloc_loccd + '店';
		$('#store-name')[0].innerHTML = storeItem.mloc_locnm;
		if (storeItem.mloc_isopen) {
			$('#mloc_isopen')[0].innerHTML = '营业中';
		} else {
			$('#mloc_isopen')[0].innerHTML = '休息中';
		}

		// $('#store-address')[0].innerHTML = storeItem.mloc_addr1;
		// $('#tel')[0].innerHTML = storeItem.mloc_telno;
		if(storeItem.mloc_tmbeg && storeItem.mloc_tmend){
			$('#mloc_time')[0].innerHTML = storeItem.mloc_tmbeg + '-' + storeItem.mloc_tmend;
		}
		
		// $('#distance')[0].innerHTML = storeItem.distance.toFixed(2);
		if (storeItem.mloc_loccd.length) {
			requestTheSolutions(storeItem.mloc_loccd);
		}


	}

	// 获取当前店的健康解决方案
	function requestTheSolutions(loccd) {
		$('.mui-slider-indicator')[0].innerHTML = '';
		$('.mui-slider-group')[0].innerHTML = '';
		var method = 'storeSolutions' + loccd;
		youpinRequest(method, {}, function(res) {
			// debug(res);
			// mui.toast('请求成功');
			solutions = res;
			showSolutions(res);
		}, function(fail) {
			mui.toast(fail);
			// requestTheSolutions('0188');
		}, function(timeout) {
			mui.toast(timeout);
		});
	}

	function solutionDetail() {
		var item = this;
		var solution_id = item.getAttribute('solution_id');
		var param = {
			'solutionID': solution_id
		};

		if (lat && lng) {
			param.userLat = lat;
			param.userLng = lng;
		}

		if (storeMes) {
			param.storeMes = storeMes;
		}
		clicked('solution-detail.html', 'solution-detail', param);
	}

	// 显示健康解决方案
	function showSolutions(solutionArray) {

		debug('showSolutions');

		for (var i = 0; i < solutionArray.length; i++) {

			var solutionItem = solutionArray[i];
			// debug(solutionItem,'solutionItem');
			var length = solutionArray.length;

			if (i == 0) {

				var lastPhoto = solutionArray[length - 1].photo;

				var firstItemDiv = document.createElement('div');
				firstItemDiv.classList.add('mui-slider-item', 'mui-slider-item-duplicate');
				$('.mui-slider-group')[0].appendChild(firstItemDiv);
				firstItemDiv.setAttribute('solution_id', solutionArray[length - 1].solution_id);

				var firstaEle = document.createElement('a');
				firstaEle.setAttribute('href', '#');
				firstItemDiv.appendChild(firstaEle);

				var firstimgEle = document.createElement('img');
				firstimgEle.setAttribute('src', lastPhoto);
				firstaEle.appendChild(firstimgEle);

			}

			var itemDiv = document.createElement('div');
			itemDiv.classList.add('mui-slider-item');
			$('.mui-slider-group')[0].appendChild(itemDiv);
			itemDiv.setAttribute('solution_id', solutionItem.solution_id);
			itemDiv.addEventListener('tap', solutionDetail);

			var aEle = document.createElement('a');
			aEle.setAttribute('href', '#');
			itemDiv.appendChild(aEle);

			var imgEle = document.createElement('img');
			imgEle.setAttribute('src', solutionItem.photo);
			aEle.appendChild(imgEle);

			var indicatorItem = document.createElement('div');
			indicatorItem.classList.add('mui-indicator');
			if (i == 0) {
				indicatorItem.classList.add('mui-active');
			}
			$('.mui-slider-indicator')[0].appendChild(indicatorItem);


			if (i == length - 1) {

				var firstPhoto = solutionArray[0].photo;

				var lastItemDiv = document.createElement('div');
				lastItemDiv.classList.add('mui-slider-item', 'mui-slider-item-duplicate');
				$('.mui-slider-group')[0].appendChild(lastItemDiv);
				lastItemDiv.setAttribute('solution_id', solutionArray[0].solution_id);

				var lastaEle = document.createElement('a');
				lastaEle.setAttribute('href', '#');
				lastItemDiv.appendChild(lastaEle);

				var lastimgEle = document.createElement('img');
				lastimgEle.setAttribute('src', firstPhoto);
				lastaEle.appendChild(lastimgEle);

			}
		}

		var slider = mui("#slider");
		slider.slider({
			interval: 3000
		});
	}

	//获取当前位置
	var refreshThePosition = function() {
		debug('click');
		
		plus.geolocation.getCurrentPosition(function(p) {
			debug(p.address,'address');
			debug(p.addresses,'addresses');
			if(p.addresses){
				document.getElementById('address').innerHTML = p.addresses;
				name = p.addresses;
			};
			if(p.address && p.addresses){
				address = p.address.city+p.address.district+p.addresses;
				city = p.address.city;
			}
			
			lat = p.coords.latitude;
			lng = p.coords.longitude;
			if(storeMes && storeMes.mloc_loccd){
				return;
			}
			getTheStoreMessageWithPoint(lng, lat);
			
		}, function(e) {
			mui.confirm('获取当前位置失败，再次尝试？\n请确认同意国珍在线App使用定位功能', '国珍在线', ['确定', '取消'], function(event) {
				if (event.index == 0) {
					refreshThePosition();
				}
			})
		},{provider:'baidu'});

		return;





		//初始化地图
		// var map = null;
		// // debug(map,'map');
		// if (!map) {
		// 	debug('hello');
		// 	map = new plus.maps.Map("map");
		// }

		// map.getUserLocation(function(state, point) {
		// 	debug(state, 'state');
		// 	debug(point);
		// 	lat = point.getLat();
		// 	lng = point.getLng();

		// 	getTheStoreMessageWithPoint(lng, lat);


		// 	if (0 == state) {
		// 		plus.maps.Map.reverseGeocode(point, {}, function(event) {
		// 			debug(event);

		// 			name = event.address;
		// 			address = event.address;

		// 			var addString = event.address; // 转换后的地理位置
		// 			addString = addString.substr(0, 11);
		// 			document.getElementById('address').innerHTML = addString;
		// 		}, function(e) {
		// 			alert("Failed:" + JSON.stringify(e));
		// 		});
		// 	} else {
		// 		mui.confirm('获取当前位置失败，再次尝试？', '国珍在线', ['确定', '取消'], function(event) {
		// 			if (event.index == 0) {
		// 				refreshThePosition();
		// 			}
		// 		})
		// 	}
		// });
	};



	// document.getElementById('address').addEventListener('tap', function() {
	// 	debug('hello');
	// 	refreshThePosition();
	// });

	mui('.mui-content').on('tap', '.store-choose', function() {

		var param = {};
		if (lat && lng && name && address) {
			param.lat = lat;
			param.lng = lng;
			param.name = name;
			param.address = address;
		}
		param.type = 'store';
		if(city && city.length){
			param.city = city;
		}

		clicked('store-choose.html', 'store-choose', param);

	})

	// document.getElementById('icon-location').addEventListener('tap', function() {
	// 	var param = {};
	// 	if (lat && lng && name && address) {
	// 		param.lat = lat;
	// 		param.lng = lng;
	// 		param.name = name;
	// 		param.address = address;
	// 	}
	// 	param.type = 'store';

	// 	clicked('store-choose.html', 'store-choose', param);
	// });

	// document.getElementById('icon-arrowdown').addEventListener('tap', function() {
	// 	clicked('store-mapchoose.html', 'store-mapchoose');
	// })

	mui('.mui-content').on('tap', '.store-message', function() {
		debug(storeMes)
		var storeName = storeMes.mloc_locnm;
		var storeAddress = storeMes.mloc_addr1;
		var storeTel = storeMes.mloc_telno;
		var param = {};
		param.userlat = lat;
		param.userlng = lng;
		param.username = name;
		param.useraddress = address;
		
		param.name = storeName;
		param.address = storeAddress;
		param.tel = storeTel;
		param.lat = storeMes.mloc_y;
		param.lng = storeMes.mloc_x;
		// if (lat && lng && name && address && storeName && storeAddress && storeTel) {
		// 	param.userlat = lat;
		// 	param.userlng = lng;
		// 	param.username = name;
		// 	param.useraddress = address;

		// 	param.name = storeName;
		// 	param.address = storeAddress;
		// 	param.tel = storeTel;
		// 	param.lat = storeMes.mloc_y;
		// 	param.lng = storeMes.mloc_x;
			

		// }
		
		if(storeMes.mloc_isopen == 1){
			var serviceState = '营业中';
			param.serviceState = serviceState;
		}else if(!storeMes.mloc_isopen || storeMes.mloc_isopen == 0){
			var serviceState = '休息中';
			param.serviceState = serviceState;
		}
		 
		if(storeMes.mloc_tmbeg && storeMes.mloc_tmend){
			var timeString = storeMes.mloc_tmbeg + '-' + storeMes.mloc_tmend; 
			param.timeString = timeString;
		}
		
		if(storeMes.mloc_maxnum || storeMes.apparatusList.length){
			var installation = '';
			// if(storeMes.apparatusList && storeMes.apparatusList.length){
			// 	for (var i = 0; i < storeMes.apparatusList.length; i++) {
			// 		var item = storeMes.apparatusList[i];
			// 		installation = installation + item + '，';
			// 	}
			// }
			if(storeMes.mloc_maxnum){
				installation = installation + '可同时接待'+storeMes.mloc_maxnum+'人，可电话预约。';
			}
			param.installation = installation;
		}
		
		// if(storeMes.membernum || storeMes.servicenum || storeMes.solutionnum){
		// 	var serviceString = '';
		// 	if(storeMes.membernum){
		// 		serviceString = serviceString + '健康顾问' + storeMes.membernum + '人';
		// 	}
		// 	if(storeMes.servicenum){
		// 		if(serviceString.length){
		// 			serviceString = serviceString + '，';
		// 		}
		// 		serviceString = serviceString + '服务项目' + storeMes.servicenum + '项';
		// 	}
		// 	if(storeMes.solutionnum){
		// 		if(serviceString.length){
		// 			serviceString = serviceString + '，';
		// 		}
		// 		serviceString = serviceString + '健康解决方案' + storeMes.solutionnum + '套'
		// 	}
		// 	if(serviceString.length){
		// 		serviceString = serviceString + '。';
		// 		param.serviceString = serviceString;
		// 	}
		// }
		if(storeMes.membernum){
			var adviserCount = '';
			adviserCount = '健康顾问' + storeMes.membernum + '人';
			param.adviserCount = adviserCount;
		}
		if(storeMes.servicenum){
			var serviceCount = '';
			serviceCount = '服务项目' + storeMes.servicenum + '项';
			param.serviceCount = serviceCount;
		}
		if(storeMes.solutionnum){
			var solutionCount = '';
			solutionCount = '健康解决方案' + storeMes.solutionnum + '套';
			param.solutionCount = solutionCount;
		}
		if(storeMes.distance){
			var distance = storeMes.distance;
			if(distance > 1000){
				distance = distance/1000;
				distance = distance.toFixed(2);
				param.distance = distance+'km';
			}else{
				distance = distance.toFixed(2);
				param.distance = distance+'m';
			}
			
		}
		
		if(storeMes.mloc_loccd){
			param.mloc_loccd = storeMes.mloc_loccd;
		}
		
		debug(param,'store-detail');
		
		clicked('store-detail.html', 'store-detail', param);
	})

	mui('.mui-content').on('tap', '.store-user-head-right', function() {
		var param = {
			'loccd': storeMes.mloc_loccd
		};
		if (lat && lng) {
			param.lat = lat;
			param.lng = lng;
		}
		param.storeMes = storeMes;
		clicked('advisers-list.html', 'advisers-list', param);
	});

	mui('.mui-content').on('tap', '.make-order', function() {

		if (!storeMes || !storeMes.mloc_loccd) {
			mui.toast('请先选择门店');
			return;
		}

		var param = {};

		if (lat && lng) {
			param.userLat = lat;
			param.userLng = lng;
		}

		if (storeMes) {
			param.storeMes = storeMes;
		}

		debug(param);
		clicked('service-list.html', 'service-list', param);
	});

	mui('.mui-content').on('tap', '.order-list', function() {
		clicked('service-order-list.html', 'service-order-list');
	});

	mui('.mui-content').on('tap', '.record-list', function() {
		var ifAdviser = $('.customer')[0].classList.contains('mui-hidden')
		clicked('record-detail.html', 'record-detail',{ifAdviser:ifAdviser});
	});
	// mui('.mui-content').on('tap','.store-services-content-item',function(){
	// 	debug('service');
	// 	clicked('service-detail.html','service-detail');
	// });

	document.addEventListener('setTag', function() {
		debug('setTag','store.js');
		//切换选项卡高亮
		// document.querySelector(".mui-bar-tab .mui-active").classList.remove("mui-active");
		var array = $('.mui-bar').find('.mui-active');
						for (var i = 0; i < array.length; i++) {
							var item = array[i];
							item.classList.remove('mui-active');
						}
		// document.getElementById("footer_custom").classList.add('mui-active');
		if(!$('.adviser')[0].classList.contains('mui-hidden')){
			document.getElementById("footer_custom").classList.add('mui-active');
		}else if(!$('.customer')[0].classList.contains('mui-hidden')){
			document.getElementById("customer_custom").classList.add('mui-active');
		}
		// document.getElementById("customer_custom").classList.add('mui-active');
		// refreshThePosition();
	});

	document.addEventListener('refreshTheStore', function(param) {
		debug(param.detail);
		getTheStoreMessageWithPoint(lng, lat, param.detail.loccd);
	});
	
	document.addEventListener('refreshThePostion',refreshThePosition);

	document.getElementById('search').addEventListener('tap', function() {
		var keyWord = document.getElementById('service-input').value;
		var param = {
			'keyWord': keyWord
		};
		if (lat && lng) {
			param.userLat = lat;
			param.userLng = lng;
		}

		if (storeMes) {
			param.storeMes = storeMes;
		}
		clicked('service-search.html', 'service-search', param);
	});

	refreshThePosition();
	
})
